#define LED_ADDR   0xFEFF0200
#define SYNTH_ADDR 0xFEFF0300

//synth control
#define SYNTH_SEL  0xFEFF03FF //0 for fm, 1 for waveguide
#define SEL_FM 0
#define SEL_WG 1

//waveguides
#define WG_VOICES  6
#define WG_ADDR    0xFEFF0310
#define WG_EN      0xFEFF0310
#define WG_RST     0xFEFF0311
#define WG_LEN     0xFEFF0312
#define wg_on(num, len) XIo_Out8(WG_LEN+((num)<<4),(len)); XIo_Out8(WG_EN+((num)<<4),1); XIo_Out8(WG_RST+((num)<<4),1); XIo_Out8(WG_RST+((num)<<4),0);
#define wg_off(num) XIo_Out8(WG_EN+((num)<<4), 0); 

//fm synths
#define FM_PATCHES 10
#define FM_VOICES  6
#define FM_ADDR    0xFEFF0370
#define FM_EN      0xFEFF0370
#define FM_THETA   0xFEFF0372
#define FM_MOD     0xFEFF03F0
#define fm_on(num, theta) XIo_Out32(FM_THETA+((num)<<4), (theta)); XIo_Out8(FM_EN+((num)<<4), 1);
#define fm_off(num) XIo_Out8(FM_EN+((num)<<4), 0); 

//midi
#define MIDI_NOTEOFF 0x8
#define MIDI_NOTEON  0x9
#define MIDI_PROG    0xc //program change
